> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gomaestro.org/llms.txt
> Use this file to discover all available pages before exploring further.

> Fill an existing peer-to-peer asset swap offer on Cardano to complete the trustless token exchange.

# Fill an offer



## OpenAPI

````yaml cardano/managed-contracts-api/openapi.json post /contracts/directSwap/fillOffer
openapi: 3.0.3
info:
  title: Cardano - Managed Contracts API
  description: https://docs.gomaestro.org/getting-started
  contact:
    name: Maestro
    email: info@gomaestro.org
    url: https://gomaestro.org/
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.txt
  version: v1.9.0
servers:
  - url: https://mainnet.gomaestro-api.org/v1
    description: Cardano Mainnet
  - url: https://preprod.gomaestro-api.org/v1
    description: Cardano Preprod
  - url: https://preview.gomaestro-api.org/v1
    description: Cardano Preview
security:
  - api-key: []
paths:
  /contracts/directSwap/fillOffer:
    post:
      tags:
        - Direct Swap
      summary: Fill an offer
      description: Fill an existing offer for direct swap
      operationId: dswap_fill_offer
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/FillOfferRequest'
      responses:
        '200':
          description: Offer filled successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Transaction'
        '400':
          description: Bad Request. Invalid request body provided.
components:
  schemas:
    FillOfferRequest:
      type: object
      properties:
        sender:
          type: string
          description: Sender's bech32 address
        offerOutRef:
          $ref: '#/components/schemas/OutRef'
          description: Offer output reference
      required:
        - sender
        - offerOutRef
    Transaction:
      type: object
      description: Unsigned transaction
      properties:
        cbor_hex:
          type: string
          description: CBOR hexadecimal representation of the transaction
        tx_hash:
          type: string
          description: Transaction hash
      required:
        - cbor_hex
        - tx_hash
    OutRef:
      type: object
      description: UTXO
      properties:
        tx_hash:
          type: string
          description: Transaction hash
        output_index:
          type: number
          description: Output index
      required:
        - tx_hash
        - output_index
  securitySchemes:
    api-key:
      type: apiKey
      in: header
      name: api-key
      description: Project API Key

````